<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Lifinity Dungeon: cpp_filrouge_iscj_allemann/include/Dice.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Lifinity Dungeon
   &#160;<span id="projectnumber">6</span>
   </div>
   <div id="projectbrief">The Lifinity Dungeon is a dungeon with an infinity of room. After each room, you found a harder room. This is why you will pass the eternity of your life in this dungeon</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7b4dd9274471389300495e9c763ca813.html">cpp_filrouge_iscj_allemann</a></li><li class="navelem"><a class="el" href="dir_e5b3fe71963387781ba01d2a56ee1874.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Dice.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_dice_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;stack&gt;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;list&gt;</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &lt;random&gt;</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span>           <span class="comment">//For getting the current time (for generator)</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &lt;type_traits&gt;</span>      <span class="comment">//For constructor specialisation</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;initializer_list&gt;</span> <span class="comment">//for using initializer_list</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_utility_8hpp.html">./Utility.hpp</a>&quot;</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_log_8hpp.html">./Log/Log.hpp</a>&quot;</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_log_collection_8hpp.html">./Log/LogCollection.hpp</a>&quot;</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">namespace </span>He_Arc::RPG</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;{</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_dice.html">   45</a></span>&#160;    <span class="keyword">class </span><a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html">Dice</a></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    {</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keyword">private</span>:</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        list&lt;T&gt; m_faces;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="keywordtype">bool</span> m_wasMinimalRoll = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="keywordtype">bool</span> m_wasMaximalRoll = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        default_random_engine m_generator; <span class="comment">// default_random_engine = simpliest gen // mt19937 = a better but cheaper gen</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="comment"></span>        <span class="keywordtype">void</span> LogDiceCreation();</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keywordtype">void</span> BuildGen();</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00086"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a4e8f421bf2aac39e1a7066c8d5192ace">   86</a></span>&#160;        <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a4e8f421bf2aac39e1a7066c8d5192ace">Dice</a>(<span class="keywordtype">int</span> nbRegularFaces = 6) requires(std::is_same_v&lt;T, <span class="keywordtype">int</span>&gt;)</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        {</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            BuildGen();</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160; </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            m_faces.clear();</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 1; i &lt;= nbRegularFaces; ++i)</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;                m_faces.push_back(i);</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            <span class="comment">// Log the creation of the dice</span></div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;            LogDiceCreation();</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        };</div>
<div class="line"><a name="l00102"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_dice.html#af6d1831d79a586e88cc8a7eaf1671cba">  102</a></span>&#160;        <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html#af6d1831d79a586e88cc8a7eaf1671cba">Dice</a>(std::initializer_list&lt;T&gt; faces); <span class="comment">//if we want to pass arguments like &quot;{item1, item2}&quot;</span></div>
<div class="line"><a name="l00109"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_dice.html#ade8f898f982a751ae3cce2e9ceb52a58">  109</a></span>&#160;<span class="comment"></span>        <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html#ade8f898f982a751ae3cce2e9ceb52a58">Dice</a>(list&lt;T&gt; faces);</div>
<div class="line"><a name="l00115"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_dice.html#ac7d6d96e13dd2fd3ec6e10a7a6348052">  115</a></span>&#160;        <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html#ac7d6d96e13dd2fd3ec6e10a7a6348052">Dice</a>(vector&lt;T&gt; faces);</div>
<div class="line"><a name="l00121"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a0e41684cd373c814801d97a8f0344511">  121</a></span>&#160;        T <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a0e41684cd373c814801d97a8f0344511">Roll</a>();</div>
<div class="line"><a name="l00127"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_dice.html#ae40dfc9d4eb9950bf2ce48933fcb0a2c">  127</a></span>&#160;        <span class="keywordtype">void</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html#ae40dfc9d4eb9950bf2ce48933fcb0a2c">RemoveFace</a>(T face);</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160; </div>
<div class="line"><a name="l00136"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a1f444ab4b72ab54d9fa85054e7ad1b12">  136</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a1f444ab4b72ab54d9fa85054e7ad1b12">GetWasMinimalRoll</a>();</div>
<div class="line"><a name="l00144"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a02bea22860ecfb54a47e70e291d5d9c1">  144</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a02bea22860ecfb54a47e70e291d5d9c1">GetWasMaximalRoll</a>();</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    };</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00154"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_dice.html#af6d1831d79a586e88cc8a7eaf1671cba">  154</a></span>&#160;    <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html">Dice&lt;T&gt;::Dice</a>(std::initializer_list&lt;T&gt; faces) : <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html">Dice</a>&lt;T&gt;(static_cast&lt;list&lt;T&gt;&gt;(faces)) {} <span class="comment">//Call the main constructor</span></div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160; </div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a4e8f421bf2aac39e1a7066c8d5192ace">Dice&lt;T&gt;::Dice</a>(std::list&lt;T&gt; faces)</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    {</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        BuildGen();</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160; </div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        m_faces = faces;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160; </div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        <span class="comment">// Log the creation of the dice</span></div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        LogDiceCreation();</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    }</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160; </div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a4e8f421bf2aac39e1a7066c8d5192ace">Dice&lt;T&gt;::Dice</a>(std::vector&lt;T&gt; faces) : Dice(Utility::VectToList(faces))</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    {</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    }</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160; </div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;    <span class="keywordtype">void</span> Dice&lt;T&gt;::LogDiceCreation()</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    {</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        std::stringstream stream;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        stream &lt;&lt; <span class="stringliteral">&quot;The dice &quot;</span> &lt;&lt; <span class="keyword">this</span> &lt;&lt; <span class="stringliteral">&quot; was created. It had &quot;</span> &lt;&lt; m_faces.size() &lt;&lt; <span class="stringliteral">&quot; faces (address of faces : &quot;</span>;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        <span class="keywordflow">for</span> (<span class="keyword">auto</span> face : m_faces)</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;            stream &lt;&lt; face &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        stream &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>;</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        <a class="code" href="class_he___arc_1_1_r_p_g_1_1_log_collection.html#a41142f3dc016102009e720426bd699ab">LogCollection::GetInstance</a>()-&gt;<a class="code" href="class_he___arc_1_1_r_p_g_1_1_log_collection.html#a21ecae9d5a43da77d6aec61d6c308caa">AddLog</a>(</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;            make_unique&lt;Log&gt;(Log{</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;                Log::LogLevel::Game, Log::LogType::Dice,</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;                stream.str()}));</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    }</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160; </div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00212"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a1f444ab4b72ab54d9fa85054e7ad1b12">  212</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a1f444ab4b72ab54d9fa85054e7ad1b12">Dice&lt;T&gt;::GetWasMinimalRoll</a>() { <span class="keywordflow">return</span> m_wasMinimalRoll; }</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00222"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a02bea22860ecfb54a47e70e291d5d9c1">  222</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a02bea22860ecfb54a47e70e291d5d9c1">Dice&lt;T&gt;::GetWasMaximalRoll</a>() { <span class="keywordflow">return</span> m_wasMaximalRoll; }</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160; </div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00231"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a0e41684cd373c814801d97a8f0344511">  231</a></span>&#160;    T <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html#a0e41684cd373c814801d97a8f0344511">Dice&lt;T&gt;::Roll</a>()</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    {</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;        uniform_int_distribution&lt;int&gt; distribution(0, m_faces.size() - 1);</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;        <span class="keyword">auto</span> index = distribution(m_generator); <span class="comment">// Get a random value</span></div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160; </div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        <span class="comment">//minimal / maximal value</span></div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        m_wasMinimalRoll = (index == 0);</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        m_wasMaximalRoll = (index == <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m_faces.size()) - 1);</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160; </div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        <span class="comment">//Element get</span></div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;        <span class="keyword">auto</span> iterator = std::next(m_faces.begin(), index);</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160; </div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;        <span class="comment">//Log the roll</span></div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        std::stringstream stream;</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        stream &lt;&lt; <span class="stringliteral">&quot;The dice &quot;</span> &lt;&lt; <span class="keyword">this</span> &lt;&lt; <span class="stringliteral">&quot; have roll the face number &quot;</span> &lt;&lt; index &lt;&lt; <span class="stringliteral">&quot;. (It had &quot;</span> &lt;&lt; m_faces.size() - 1 &lt;&lt; <span class="stringliteral">&quot; faces (0-n))&quot;</span>;</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160; </div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        <a class="code" href="class_he___arc_1_1_r_p_g_1_1_log_collection.html#a41142f3dc016102009e720426bd699ab">LogCollection::GetInstance</a>()-&gt;<a class="code" href="class_he___arc_1_1_r_p_g_1_1_log_collection.html#a21ecae9d5a43da77d6aec61d6c308caa">AddLog</a>(</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;            make_unique&lt;Log&gt;(<a class="code" href="class_he___arc_1_1_r_p_g_1_1_log.html">Log</a>{</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;                Log::LogLevel::Game, Log::LogType::Dice,</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;                stream.str()}));</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160; </div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        <span class="keywordflow">return</span> *iterator;</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    }</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160; </div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00262"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_dice.html#ae40dfc9d4eb9950bf2ce48933fcb0a2c">  262</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html#ae40dfc9d4eb9950bf2ce48933fcb0a2c">Dice&lt;T&gt;::RemoveFace</a>(T face)</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    {</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        <span class="comment">//There is no problem if trying to remove a non existing face, no exception will throw</span></div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;        m_faces.remove(face);</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    }</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160; </div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html">Dice&lt;T&gt;::BuildGen</a>()</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    {</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">int</span> modifier = 0; <span class="comment">//Different random for each instance (without, if 2 dice instancied in a row, the generator will be the same)</span></div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;        modifier++;</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160; </div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        <span class="comment">//https://spc.unige.ch/en/teaching/courses/algorithmes-probabilistes/random-numbers-week-1/</span></div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;        <span class="comment">//m_generator(std::chrono::system_clock::now().time_since_epoch().count()); // Not working</span></div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160; </div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;        <span class="comment">/*</span></div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;<span class="comment">        * the random will give new values after any execution of the code</span></div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;<span class="comment">        * The sequence will be unique for each instance</span></div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;<span class="comment">        */</span></div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;        m_generator = std::default_random_engine(std::chrono::system_clock::now().time_since_epoch().count() * modifier); <span class="comment">//if use + instead of *, modifier had sometimes same sequences as without modifier</span></div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;        <span class="comment">/*</span></div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;<span class="comment">        * the random will give same values after any execution of the code</span></div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;<span class="comment">        * The sequence will be unique for each instance</span></div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;<span class="comment">        */</span></div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        <span class="comment">//m_generator = std::default_random_engine(modifier);</span></div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;        <span class="comment">/*</span></div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;<span class="comment">        * the random will give same values after any execution of the code</span></div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;<span class="comment">        * The sequence will be the same, for instance declared in a row</span></div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;<span class="comment">        */</span></div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        <span class="comment">// m_generator = std::default_random_engine();</span></div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    }</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;} <span class="comment">// namespace He_Arc::RPG</span></div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160; </div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;<span class="comment">/* OLD CODE</span></div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;<span class="comment">    // Old method constr specialisation</span></div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;<span class="comment">    </span></div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;<span class="comment">    // template &lt;typename T&gt;</span></div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;<span class="comment">    // Dice&lt;T&gt;::Dice(int nbRegularFaces)</span></div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;<span class="comment">    // {</span></div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;<span class="comment">    //     BuildGen();</span></div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;<span class="comment"></span> </div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;<span class="comment">    //     m_faces.clear();</span></div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;<span class="comment">    //     for (int i = 1; i &lt;= nbRegularFaces; ++i)</span></div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;<span class="comment">    //         m_faces.push_back(i);</span></div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;<span class="comment">    // }</span></div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;<span class="comment"></span> </div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;<span class="comment">*/</span></div>
<div class="ttc" id="a_log_8hpp_html"><div class="ttname"><a href="_log_8hpp.html">Log.hpp</a></div><div class="ttdoc">: Header file, for the class &quot;Log.cpp&quot;</div></div>
<div class="ttc" id="a_log_collection_8hpp_html"><div class="ttname"><a href="_log_collection_8hpp.html">LogCollection.hpp</a></div><div class="ttdoc">: Header file, for the class &quot;LogCollection.cpp&quot;</div></div>
<div class="ttc" id="a_utility_8hpp_html"><div class="ttname"><a href="_utility_8hpp.html">Utility.hpp</a></div><div class="ttdoc">: Header file, for the class &quot;Utility.cpp&quot;</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_dice_html"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_dice.html">He_Arc::RPG::Dice</a></div><div class="ttdoc">Class for the dice, gives you a random value depending the type of dice.</div><div class="ttdef"><b>Definition:</b> Dice.hpp:46</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_dice_html_a02bea22860ecfb54a47e70e291d5d9c1"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_dice.html#a02bea22860ecfb54a47e70e291d5d9c1">He_Arc::RPG::Dice::GetWasMaximalRoll</a></div><div class="ttdeci">bool GetWasMaximalRoll()</div><div class="ttdoc">Get the information if last roll was a maximal.</div><div class="ttdef"><b>Definition:</b> Dice.hpp:222</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_dice_html_a0e41684cd373c814801d97a8f0344511"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_dice.html#a0e41684cd373c814801d97a8f0344511">He_Arc::RPG::Dice::Roll</a></div><div class="ttdeci">T Roll()</div><div class="ttdoc">Perform a roll of the dice and get a random value.</div><div class="ttdef"><b>Definition:</b> Dice.hpp:231</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_dice_html_a1f444ab4b72ab54d9fa85054e7ad1b12"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_dice.html#a1f444ab4b72ab54d9fa85054e7ad1b12">He_Arc::RPG::Dice::GetWasMinimalRoll</a></div><div class="ttdeci">bool GetWasMinimalRoll()</div><div class="ttdoc">Get the information if last roll was a minimal.</div><div class="ttdef"><b>Definition:</b> Dice.hpp:212</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_dice_html_a4e8f421bf2aac39e1a7066c8d5192ace"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_dice.html#a4e8f421bf2aac39e1a7066c8d5192ace">He_Arc::RPG::Dice::Dice</a></div><div class="ttdeci">Dice(int nbRegularFaces=6) requires(std</div><div class="ttdoc">Constructor for a int Dice only it set the faces from 1 to the number (included)</div><div class="ttdef"><b>Definition:</b> Dice.hpp:86</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_dice_html_ac7d6d96e13dd2fd3ec6e10a7a6348052"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_dice.html#ac7d6d96e13dd2fd3ec6e10a7a6348052">He_Arc::RPG::Dice::Dice</a></div><div class="ttdeci">Dice(vector&lt; T &gt; faces)</div><div class="ttdoc">Construct a new Dice object.</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_dice_html_ade8f898f982a751ae3cce2e9ceb52a58"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_dice.html#ade8f898f982a751ae3cce2e9ceb52a58">He_Arc::RPG::Dice::Dice</a></div><div class="ttdeci">Dice(list&lt; T &gt; faces)</div><div class="ttdoc">Construct a new Dice object.</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_dice_html_ae40dfc9d4eb9950bf2ce48933fcb0a2c"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_dice.html#ae40dfc9d4eb9950bf2ce48933fcb0a2c">He_Arc::RPG::Dice::RemoveFace</a></div><div class="ttdeci">void RemoveFace(T face)</div><div class="ttdoc">Remove a face of the dice.</div><div class="ttdef"><b>Definition:</b> Dice.hpp:262</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_dice_html_af6d1831d79a586e88cc8a7eaf1671cba"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_dice.html#af6d1831d79a586e88cc8a7eaf1671cba">He_Arc::RPG::Dice::Dice</a></div><div class="ttdeci">Dice(std::initializer_list&lt; T &gt; faces)</div><div class="ttdoc">Construct a new Dice object.</div><div class="ttdef"><b>Definition:</b> Dice.hpp:154</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_log_collection_html_a21ecae9d5a43da77d6aec61d6c308caa"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_log_collection.html#a21ecae9d5a43da77d6aec61d6c308caa">He_Arc::RPG::LogCollection::AddLog</a></div><div class="ttdeci">void AddLog(unique_ptr&lt; Log &gt; log)</div><div class="ttdoc">Add a log to the collection.</div><div class="ttdef"><b>Definition:</b> LogCollection.cpp:153</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_log_collection_html_a41142f3dc016102009e720426bd699ab"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_log_collection.html#a41142f3dc016102009e720426bd699ab">He_Arc::RPG::LogCollection::GetInstance</a></div><div class="ttdeci">static LogCollection * GetInstance()</div><div class="ttdoc">Get the Instance of the LogCollection.</div><div class="ttdef"><b>Definition:</b> LogCollection.cpp:104</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_log_html"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_log.html">He_Arc::RPG::Log</a></div><div class="ttdoc">This class is an entry of logs, an entry is caracterised by the level of the log; the type; and the m...</div><div class="ttdef"><b>Definition:</b> Log.hpp:36</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
